# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/jboss-vfs/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define oname jboss-vfs
%define reltag .GA
%global namedversion %{version}%{?reltag}

Name:           jboss-vfs2
Version:        2.2.1
Release:        2%{?reltag}%{?dist}
Epoch:          0
Summary:        JBoss VFS
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org
# git clone https://github.com/jbossas/jboss-vfs/
# cd jboss-vfs
# git chekcout 2.2.1.GA
# HEAD is now at 5adf4e5... Prep 2.2.1.GA
# cd ..
# rm jboss-vfs/.git -rf
# tar -jcf jboss-vfs-2.2.1.GA.tar.bz2 jboss-vfs
Source0:        jboss-vfs-2.2.1.GA.tar.bz2
Source1:        jboss-vfs2-jpp-depmap.xml
Source2:        jboss-vfs2-settings.xml
Source3:        jboss-vfs-component-info.xml
Obsoletes:      jboss-vfs < %{epoch}:%{version}-%{release}
Provides:       jboss-vfs = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       java >= 0:1.5.0
Requires:       jboss-common-core >= 0:2.2.13
Requires:       jboss-common-logging-spi >= 0:2.0.5
BuildRequires:  java-devel
BuildRequires:  jboss-parent
BuildRequires:  jboss-common-core >= 0:2.2.13
BuildRequires:  jboss-common-logging-spi >= 0:2.0.5
BuildRequires:  jboss-test >= 0:1.1.0
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  junit4
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss VFS library.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{oname}

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file:`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file:`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file:`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:%{_datadir}/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:%{_datadir}/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven2.test.failure.ignore=true \
        -DaltDeploymentRepository=jboss-releases::default::file:maven2-brew \
        install deploy:deploy javadoc:javadoc

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
cp -p target/%{oname}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{namedversion}.jar
ln -s %{name}-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/jboss-vfs-%{namedversion}.jar
%add_to_maven_depmap org.jboss %{oname} %{namedversion} JPP %{name}
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{namedversion}*; do ln -s ${jar} `echo ${jar} | sed  "s|-%{namedversion}||g"`; done)

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

mkdir -p $RPM_BUILD_ROOT%{repodir}
mkdir -p $RPM_BUILD_ROOT%{repodirlib}
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{namedversion}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
mkdir -p $RPM_BUILD_ROOT%{repodirsrc}
cp -p %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{namedversion}.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-vfs.jar
cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/jboss-vfs.pom
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/jboss-vfs-%{namedversion}.jar
%{_javadir}*/jboss-vfs.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Aug 09 2012 Hui Wang <huwang@redhat.com> 0:2.2.1-2.GA
- Rebuild

* Thu Aug 09 2012 Hui Wang <huwang@redhat.com> 0:2.2.1-1.GA
- Sync with jb-eap-5-rhel-6

* Wed Apr 06 2011 David Walluck <dwalluck@redhat.com> 0:2.2.0-4.SP1.3
- don't Requires: junit
- remove codehaus-stax11 from jpp-depmap.xml (not even in BR)
- javadoc pkg Requires: jpackage-utils
- add corresponding Provides for Obsoletes
- use full version in jar and dir names

* Wed Mar 16 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.0-4.SP1.2
- Remove R maven2, jboss-test

* Fri Mar 11 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.0-4.SP1.1
- Fix Release number
- Recover spec file from previous version

* Tue Feb 15 2011 Hui Wang <huwang@redhat.com> - 0:2.2.0-2.SP1
- Add Obsoletes jboss-vfs
- Fix version in install section
- Add depmap entrance for qdox

* Sat Feb 12 2011 Hui Wang <huwang@redhat.com> - 0:2.2.0-1.SP1
- Update to 2.2.0.SP1
- Clearups

* Fri Jan 21 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.2.0-4
- Add patch to adjust jboss-parent version
- Change BR junit44 to junit4

* Fri Dec 10 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.2.0-3
- Build with maven 2.2.1
- Change BR maven release to maven-release-plugin
- Add BR maven-deploy-plugin, maven-site-plugin

* Fri Jul 09 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.2.0-2
- Add Obsoletes jboss-vfs
- Add BR codehaus-stax11-api, xerces-j2, xml-commons-jaxp-1.3-apis

* Wed Jun 02 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.2.0-1.1
- Add BR dtdparser, xml-commons-jaxp-1.3-apis

* Wed May 26 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.2.0-1
- Upgrade to 2.2.0.GA
- Add BR maven2-plugin-idea

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.1.3-2.1.1
- rebuilt

* Tue Apr 6 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.1.3-2.1
- Rebuild

* Wed Sep 23 2009 Fernando Nasser <fnasser@redhat.com> 0:2.1.3-2
- Rebuild with signing

* Tue Sep 22 2009 Martha Benitez <mbenitez@redhat.com> 0:2.1.3-1
- Upgrade to 2.1.3.SP1
- Add BR jboss-naming

* Thu Jun 18 2009 David Walluck <dwalluck@redhat.com> 0:2.1.2-2
- add repolib
- install symlink to upstream name

* Wed Jun 10 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.1.2-1.jpp5
- first release
